## xen 4.2.1

=== xen/Makefile ===
# This is the correct place to edit the build version.
# All other places this is stored (eg. compile.h) should be autogenerated.
export XEN_VERSION       = 4
export XEN_SUBVERSION    = 2
export XEN_EXTRAVERSION ?= .1$(XEN_VENDORVERSION)
export XEN_FULLVERSION   = $(XEN_VERSION).$(XEN_SUBVERSION)$(XEN_EXTRAVERSION)
-include xen-version

export XEN_WHOAMI	?= $(USER)
export XEN_DOMAIN	?= $(shell ([ -x /bin/dnsdomainname ] && /bin/dnsdomainname) || ([ -x /bin/domainname ] && /bin/domainname || echo [unknown]))

export BASEDIR := $(CURDIR)
export XEN_ROOT := $(BASEDIR)/..

EFI_MOUNTPOINT ?= /boot/efi

.PHONY: default
default: build

.PHONY: dist
dist: install

.PHONY: build install uninstall clean distclean cscope TAGS tags MAP gtags
build install uninstall debug clean distclean cscope TAGS tags MAP gtags::
	$(MAKE) -f Rules.mk _$@

.PHONY: _build
_build: $(TARGET).gz

.PHONY: _install
_install: $(TARGET).gz
	[ -d $(DESTDIR)/boot ] || $(INSTALL_DIR) $(DESTDIR)/boot
	$(INSTALL_DATA) $(TARGET).gz $(DESTDIR)/boot/$(notdir $(TARGET))-$(XEN_FULLVERSION).gz
	ln -f -s $(notdir $(TARGET))-$(XEN_FULLVERSION).gz $(DESTDIR)/boot/$(notdir $(TARGET))-$(XEN_VERSION).$(XEN_SUBVERSION).gz
	ln -f -s $(notdir $(TARGET))-$(XEN_FULLVERSION).gz $(DESTDIR)/boot/$(notdir $(TARGET))-$(XEN_VERSION).gz
	ln -f -s $(notdir $(TARGET))-$(XEN_FULLVERSION).gz $(DESTDIR)/boot/$(notdir $(TARGET)).gz
	$(INSTALL_DATA) $(TARGET)-syms $(DESTDIR)/boot/$(notdir $(TARGET))-syms-$(XEN_FULLVERSION)
	if [ -r $(TARGET).efi -a -n '$(EFI_DIR)' ]; then \
		[ -d $(DESTDIR)$(EFI_DIR) ] || $(INSTALL_DIR) $(DESTDIR)$(EFI_DIR); \
		$(INSTALL_DATA) $(TARGET).efi $(DESTDIR)$(EFI_DIR)/$(notdir $(TARGET))-$(XEN_FULLVERSION).efi; \
		ln -sf $(notdir $(TARGET))-$(XEN_FULLVERSION).efi $(DESTDIR)$(EFI_DIR)/$(notdir $(TARGET))-$(XEN_VERSION).$(XEN_SUBVERSION).efi; \
		ln -sf $(notdir $(TARGET))-$(XEN_FULLVERSION).efi $(DESTDIR)$(EFI_DIR)/$(notdir $(TARGET))-$(XEN_VERSION).efi; \
		ln -sf $(notdir $(TARGET))-$(XEN_FULLVERSION).efi $(DESTDIR)$(EFI_DIR)/$(notdir $(TARGET)).efi; \
		if [ -n '$(EFI_MOUNTPOINT)' -a -n '$(EFI_VENDOR)' ]; then \
			$(INSTALL_DATA) $(TARGET).efi $(DESTDIR)$(EFI_MOUNTPOINT)/efi/$(EFI_VENDOR)/$(notdir $(TARGET))-$(XEN_FULLVERSION).efi; \
		elif [ "$(DESTDIR)" = "$(patsubst $(shell cd $(XEN_ROOT) && pwd)/%,%,$(DESTDIR))" ]; then \
			echo 'EFI installation only partially done (EFI_VENDOR not set)' >&2; \
		fi; \
	fi

.PHONY: _uninstall
_uninstall: D=$(DESTDIR)
_uninstall: T=$(notdir $(TARGET))
_uninstall:
	rm -f $(D)/boot/$(T)-$(XEN_FULLVERSION).gz
	rm -f $(D)/boot/$(T)-$(XEN_VERSION).$(XEN_SUBVERSION).gz
	rm -f $(D)/boot/$(T)-$(XEN_VERSION).gz
	rm -f $(D)/boot/$(T).gz
	rm -f $(D)/boot/$(T)-syms-$(XEN_FULLVERSION)
	rm -f $(D)$(EFI_DIR)/$(T)-$(XEN_FULLVERSION).efi
	rm -f $(D)$(EFI_DIR)/$(T)-$(XEN_VERSION).$(XEN_SUBVERSION).efi
	rm -f $(D)$(EFI_DIR)/$(T)-$(XEN_VERSION).efi
	rm -f $(D)$(EFI_DIR)/$(T).efi
	rm -f $(D)$(EFI_MOUNTPOINT)/efi/$(EFI_VENDOR)/$(T)-$(XEN_FULLVERSION).efi

.PHONY: _debug
_debug:
	objdump -D -S $(TARGET)-syms > $(TARGET).s

.PHONY: _clean
_clean: delete-unfresh-files
	$(MAKE) -C tools clean
	$(MAKE) -f $(BASEDIR)/Rules.mk -C include clean
	$(MAKE) -f $(BASEDIR)/Rules.mk -C common clean
	$(MAKE) -f $(BASEDIR)/Rules.mk -C drivers clean
	$(MAKE) -f $(BASEDIR)/Rules.mk -C xsm clean
	$(MAKE) -f $(BASEDIR)/Rules.mk -C crypto clean
	$(MAKE) -f $(BASEDIR)/Rules.mk -C arch/$(TARGET_ARCH) clean
	rm -f include/asm *.o $(TARGET) $(TARGET).gz $(TARGET)-syms *~ core
	rm -f include/asm-*/asm-offsets.h
	[ -d tools/figlet ] && rm -f .banner*

.PHONY: _distclean
_distclean: clean
	rm -f tags TAGS cscope.files cscope.in.out cscope.out cscope.po.out GTAGS GPATH GRTAGS GSYMS

$(TARGET).gz: $(TARGET)
	gzip -f -9 < $< > $@.new
	mv $@.new $@

$(TARGET): delete-unfresh-files
	$(MAKE) -C tools
	$(MAKE) -f $(BASEDIR)/Rules.mk include/xen/compile.h
	[ -e include/asm ] || ln -sf asm-$(TARGET_ARCH) include/asm
	$(MAKE) -f $(BASEDIR)/Rules.mk -C include
	$(MAKE) -f $(BASEDIR)/Rules.mk -C arch/$(TARGET_ARCH) asm-offsets.s
	$(MAKE) -f $(BASEDIR)/Rules.mk include/asm-$(TARGET_ARCH)/asm-offsets.h
	$(MAKE) -f $(BASEDIR)/Rules.mk -C arch/$(TARGET_ARCH) $(TARGET)

# drivers/char/console.o contains static banner/compile info. Blow it away.
# Don't refresh these files during e.g., 'sudo make install'
.PHONY: delete-unfresh-files
delete-unfresh-files:
	@if [ ! -r include/xen/compile.h -o -O include/xen/compile.h ]; then \
		rm -f include/xen/compile.h; \
	fi

.banner: Makefile
	$(MAKE) -C tools
	@tools/figlet/figlet -d tools/figlet Xen $(XEN_FULLVERSION) 2>$@2 >$@1
	@cat $@1 $@2 >$@
	@rm -f $@1 $@2

# compile.h contains dynamic build info. Rebuilt on every 'make' invocation.
include/xen/compile.h: include/xen/compile.h.in .banner
	@sed -e 's/@@date@@/$(shell LC_ALL=C date)/g' \
	    -e 's/@@time@@/$(shell LC_ALL=C date +%T)/g' \
	    -e 's/@@whoami@@/$(XEN_WHOAMI)/g' \
	    -e 's/@@domain@@/$(XEN_DOMAIN)/g' \
	    -e 's/@@hostname@@/$(shell hostname)/g' \
	    -e 's!@@compiler@@!$(shell $(CC) $(CFLAGS) --version 2>&1 | head -1)!g' \
	    -e 's/@@version@@/$(XEN_VERSION)/g' \
	    -e 's/@@subversion@@/$(XEN_SUBVERSION)/g' \
	    -e 's/@@extraversion@@/$(XEN_EXTRAVERSION)/g' \
	    -e 's!@@changeset@@!$(shell ((hg parents --template "{date|date} {rev}:{node|short}" >/dev/null && hg parents --template "{date|date} {rev}:{node|short}") || echo "unavailable") 2>/dev/null)!g' \
	    < include/xen/compile.h.in > $@.new
	@grep \" .banner >> $@.new
	@grep -v \" .banner
	@mv -f $@.new $@

include/asm-$(TARGET_ARCH)/asm-offsets.h: arch/$(TARGET_ARCH)/asm-offsets.s
	@(set -e; \
	  echo "/*"; \
	  echo " * DO NOT MODIFY."; \
	  echo " *"; \
	  echo " * This file was auto-generated from $<"; \
	  echo " *"; \
	  echo " */"; \
	  echo ""; \
	  echo "#ifndef __ASM_OFFSETS_H__"; \
	  echo "#define __ASM_OFFSETS_H__"; \
	  echo ""; \
	  sed -ne "/^->/{s:^->\([^ ]*\) [\$$#]*\([^ ]*\) \(.*\):#define \1 \2 /* \3 */:; s:->::; p;}"; \
	  echo ""; \
	  echo "#endif") <$< >$@

SUBDIRS = xsm arch/$(TARGET_ARCH) common drivers
define all_sources
    ( find include/asm-$(TARGET_ARCH) -name '*.h' -print; \
      find include -name 'asm-*' -prune -o -name '*.h' -print; \
      find $(SUBDIRS) -name '*.[chS]' -print )
endef

define set_exuberant_flags
    exuberant_flags=`$1 --version 2>/dev/null | (grep -iq exuberant && \
	echo "-I __initdata,__exitdata,__acquires,__releases \
	    -I EXPORT_SYMBOL,EXPORT_SYMBOL_GPL \
	    --extra=+f --c-kinds=+px") || true` 
endef

.PHONY: xenversion
xenversion:
	@echo $(XEN_FULLVERSION)

.PHONY: _TAGS
_TAGS: 
	set -e; rm -f TAGS; \
	$(call set_exuberant_flags,etags); \
	$(all_sources) | xargs etags $$exuberant_flags -a

.PHONY: _tags
_tags: 
	set -e; rm -f tags; \
	$(call set_exuberant_flags,ctags); \
	$(all_sources) | xargs ctags $$exuberant_flags -a

.PHONY: _gtags
_gtags:
	set -e; rm -f GTAGS GSYMS GPATH GRTAGS
	$(all_sources) | gtags -f -

.PHONY: _cscope
_cscope:
	$(all_sources) > cscope.files
	cscope -k -b -q

.PHONY: _MAP
_MAP:
	$(NM) -n $(TARGET)-syms | grep -v '\(compiled\)\|\(\.o$$\)\|\( [aUw] \)\|\(\.\.ng$$\)\|\(LASH[RL]DI\)' > System.map

.PHONY: FORCE
FORCE:

%.o %.i: %.c FORCE
	$(MAKE) -f $(BASEDIR)/Rules.mk -C $(*D) $(@F)

%.o %.s: %.S FORCE
	$(MAKE) -f $(BASEDIR)/Rules.mk -C $(*D) $(@F)

%/: FORCE
	$(MAKE) -f $(BASEDIR)/Rules.mk -C $* built_in.o built_in_bin.o

=== debian/changelog ===
xen (4.2.1-0ubuntu3) raring; urgency=low

  * Fix FTBS on i386
    - 0007-x86-Fix-i386-virtual-apic.patch
  * Fix HVM VCPUs getting stuck on boot when host supports SMEP (LP: #1157757)
    - 0008-vmx-Simplify-cr0-update-handling-by-deferring-cr4-ch.patch
    - 0009-VMX-disable-SMEP-feature-when-guest-is-in-non-paging.patch
    - 0010-VMX-Always-disable-SMEP-when-guest-is-in-non-paging-.patch

 -- Stefan Bader <stefan.bader@canonical.com>  Fri, 05 Apr 2013 16:39:45 +0200

xen (4.2.1-0ubuntu2) raring; urgency=low

  * Backporting support for Intel APIC virtualization (LP: #1160373)
    - 0001-xen-enable-APIC-Register-Virtualization.patch
    - 0002-xen-enable-Virtual-interrupt-delivery.patch
    - 0003-xen-add-virtual-x2apic-support-for-apicv.patch
  * Backporting support for Intel TSC adjust (LP: #1160378)
    - 0004-x86-Implement-TSC-adjust-feature-for-HVM-guest.patch
    - 0005-x86-Save-restore-TSC-adjust-during-HVM-guest-migrati.patch
    - 0006-x86-Expose-TSC-adjust-to-HVM-guest.patch

 -- Stefan Bader <stefan.bader@canonical.com>  Tue, 26 Mar 2013 09:41:25 +0100

xen (4.2.1-0ubuntu1) raring; urgency=low

  * New upstream stable release. Remaining changes:
    - Fix to qemu for CVE-2012-6075
    - Patches for XSA33-36 and 38
    - qemu-fix-librt-test.patch
      Fix build regression caused by glibc not requiring to link against
      librt for the clock_gettime function. Patch picked from xen-devel
      mailing list.
    - tools-gdbsx-fix-build-failure-with-glibc-2.17.patch
      Add direct include to sys/types.h for xg_main.c which likely was
      indirectly done before. Needed to get ulong type definition.
    - tools-ocaml-fix-build: refresh and reenable (and fix the description
      of) this patch.  Without it the ocam native libraries (*.cmxa)
      build in /build local paths rather than appropriatly versioned
      library references.
    - Use dpkg-buildflags and strip the gcc prefix for getting LDFLAGS.
      This will again use the Ubuntu specific LDFLAGS (using some
      hardening options). Older releases would always pass those options
      in the environment but that changed.
    - Ressurrect qemu-dm for now (upstream qemu would not support
      migration, yet). Forward-port some patches from the old Debian
      package which still included qemu-dm:
      - qemu-prefix (modify LDFLAGS to point to lib dir for qemu-dm)
      - qemu-disable-blktap (this is not present in upstream)
      - ubuntu-qemu-disable-qemu-upstream (breaks build and also should
        be provided by qemu/kvm package)
    - Build depend on kvm-ipxe (instead of ipxe) as it is smaller and fix
      up hvmloader build. kvm-ipxe contains a subset of the rom files from
      which the Xen build only uses two to be embedded in the hvmloader.
    - debian/patches/silence-gcc-warnings.patch: Silence gcc warnings.

 -- Stefan Bader <stefan.bader@canonical.com>  Fri, 08 Mar 2013 10:34:54 +0100

=== debian/control ===
Source: xen
Section: kernel
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian Xen Team <pkg-xen-devel@lists.alioth.debian.org>
Uploaders: Guido Trotter <ultrotter@debian.org>, Bastian Blank <waldi@debian.org>
Standards-Version: 3.9.2
Build-Depends: debhelper (>> 7), dpkg-dev (>= 1.16.0~), lsb-release, python-dev, bcc, gcc-multilib, e2fslibs-dev, iasl, kvm-ipxe, libaio-dev, libglib2.0-dev, libgnutls-dev, liblzma-dev, libncurses5-dev, libpci-dev, libyajl-dev, pkg-config, uuid-dev, zlib1g-dev, ocaml-nox, dh-ocaml, ocaml-findlib, libssl-dev
Build-Depends-Indep: graphviz, ghostscript, texlive-fonts-recommended, texlive-font-utils, texlive-latex-recommended
XS-Python-Version: current

Package: xen-docs-4.2
Architecture: all
Section: doc
Depends: ${misc:Depends}
Description: Documentation for Xen
 This package contains all the large documentation files for Xen.  This
 includes a description interface (both the API, and a nice explanation of
 how XEN works).

Package: libxen-4.2
Architecture: amd64 i386
Section: libs
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Public libs for Xen
 This package contains the shared libraries for Xen.

Package: libxenstore3.0
Architecture: amd64 i386
Section: libs
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Xenstore communications library for Xen
 This package contains the public libxenstore.

Package: libxen-dev
Architecture: amd64 i386
Section: libdevel
Depends: libxen-4.2 (= ${binary:Version}), libxenstore3.0 (= ${binary:Version}), ${misc:Depends}
Description: Public headers and libs for Xen
 This package contains the public headers and static libraries for Xen.

Package: xenstore-utils
Architecture: amd64 i386
Section: admin
Depends: ${shlibs:Depends}, ${misc:Depends}
Replaces: xen-utils-common (<= 3.1.0-1)
Conflicts: xen-utils-common (<= 3.1.0-1)
Description: Xenstore utilities for Xen
 This package contains the Xenstore utilities.

Package: libxen-ocaml
Architecture: amd64 i386
Section: ocaml
Provides: ${ocaml:Provides}
Depends: ${shlibs:Depends}, ${misc:Depends}, ${ocaml:Depends}
Description: OCaml libraries for controlling Xen
 This package contains the runtime libraries required for the ocaml
 bindings to the Xen control libraries.

Package: libxen-ocaml-dev
Architecture: amd64 i386
Section: ocaml
Provides: ${ocaml:Provides}
Depends: libxen-ocaml (= ${binary:Version}), libxen-dev (= ${binary:Version}), ${shlibs:Depends}, ${misc:Depends}, ${ocaml:Depends}
Description: OCaml libraries for controlling Xen (devel package)
 This package contains the ocaml findlib packages for compiling
 applications that are designed to control the Xen hypervisor.

Package: xen-utils-common
Architecture: all
Depends: gawk, lsb-base, python, udev, xenstore-utils, ${misc:Depends}
Description: Xen administrative tools - common files
 The userspace tools to manage a system virtualized through the Xen virtual
 machine monitor.

Package: xen-utils-4.2
Architecture: amd64 i386
Provides: xen-utils
Depends: ${shlibs:Depends}, ${misc:Depends}, ${python:Depends}, xen-utils-common (>= ${source:Version})
Recommends: bridge-utils, libc6-xen [i386], xen-hypervisor-4.2, qemu-keymaps, qemu-utils
Suggests: xen-docs-4.2
Description: XEN administrative tools
 The userspace tools to manage a system virtualized through the XEN virtual
 machine monitor.
Built-Using: ${misc:Built-Using}

Package: xen-hypervisor-4.2-amd64
Architecture: amd64 i386
Provides: xen-hypervisor, xen-hypervisor-4.2, xen-hypervisor-amd64
Depends: ${misc:Depends}
Recommends: xen-utils-4.2
Suggests: xen-docs-4.2
Description: Xen Hypervisor on AMD64
 The hypervisor is the "core" for XEN itself.  It gets booted by the boot
 loader and controls cpu and memory, sharing them between your
 administrative domain (Domain 0) and the virtual guest systems.
 .
 In order to boot a XEN system along with this package you also need a
 kernel specifically crafted to work as the Domain 0, mediating hardware
 access for XEN itself.

Package: xen-system-amd64
Architecture: amd64 i386
Provides: xen-system
Depends: xen-hypervisor-4.2-amd64, xen-utils-4.2, ${misc:Depends}
Description: Xen System on AMD64 (meta-package)
 This package depends on the latest Xen hypervisor for use on AMD64 and the
 Xen utils.

Package: xen-hypervisor-4.2-i386
Architecture: i386
Provides: xen-hypervisor, xen-hypervisor-4.2, xen-hypervisor-i386
Depends: ${misc:Depends}
Recommends: xen-utils-4.2
Suggests: xen-docs-4.2
Description: Xen Hypervisor on i386
 The hypervisor is the "core" for XEN itself.  It gets booted by the boot
 loader and controls cpu and memory, sharing them between your
 administrative domain (Domain 0) and the virtual guest systems.
 .
 In order to boot a XEN system along with this package you also need a
 kernel specifically crafted to work as the Domain 0, mediating hardware
 access for XEN itself.

Package: xen-system-i386
Architecture: i386
Provides: xen-system
Depends: xen-hypervisor-4.2-i386, xen-utils-4.2, ${misc:Depends}
Description: Xen System on i386 (meta-package)
 This package depends on the latest Xen hypervisor for use on i386 and the
 Xen utils.

=== debian/rules ===
#!/usr/bin/make -f

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

# Ubuntu passes LDFLAGS suitable for gcc by default (-Wl prefix) but
# Xen passes LDFLAGS directly to ld (not through gcc), so this fails.
# Strip the prefix from the LDFLAGS.
LDFLAGS = $(shell dpkg-buildflags --get LDFLAGS|sed -e 's/-Wl,//g')

DEB_HOST_ARCH  := $(shell dpkg-architecture -qDEB_HOST_ARCH)
DEB_BUILD_ARCH := $(shell dpkg-architecture -qDEB_BUILD_ARCH)

SOURCE := $(shell dpkg-parsechangelog | sed -ne 's,^Source: *\(.*\)$$,\1,p')
VERSION := $(shell dpkg-parsechangelog | sed -ne 's,^Version: *\(.*\)$$,\1,p')
VERSION_UPSTREAM := $(shell echo "$(VERSION)" | sed -e 's,-[^-]*$$,,')
VERSION_BINNMU := $(shell echo "$(VERSION)" | sed -ne 's,.*\+b\(.*\)$$,\1,p')

stamp = [ -d $(dir $@) ] || mkdir $(dir $@); touch $@

include debian/rules.defs

setup: debian/control
	dh_testdir
	$(MAKE) -f debian/rules.gen setup_$(DEB_HOST_ARCH)
	@$(stamp)

build: build-arch build-indep

build-arch: setup
	dh_testdir
	$(MAKE) -f debian/rules.gen build-arch_$(DEB_HOST_ARCH)
	@$(stamp)

build-indep: setup
	dh_testdir
	$(MAKE) -f debian/rules.gen build-indep
	@$(stamp)

maintainerclean:
	rm -f debian/control* debian/rules.gen debian/xen-hypervisor-* debian/xen-utils-[0-9]*
	rm -rf $(filter-out .svn debian, $(wildcard * .[^.]*))

clean: debian/control
	dh_testdir
	rm -rf $(BUILD_DIR) $(STAMPS_DIR) debian/lib/python/debian_xen/*.pyc
	dh_clean

binary-indep:
	dh_testdir
	$(MAKE) -f debian/rules.gen binary-indep

binary-arch:
	dh_testdir
	$(MAKE) -f debian/rules.gen binary-arch_$(DEB_HOST_ARCH)

binary:	binary-indep binary-arch

DIR_ORIG = ../orig/$(SOURCE)-$(VERSION_UPSTREAM)
TAR_ORIG_MAIN_NAME = $(SOURCE)_$(VERSION_UPSTREAM).orig.tar.gz
TAR_ORIG_MAIN = $(firstword $(wildcard ../$(TAR_ORIG_MAIN_NAME)) $(wildcard ../orig/$(TAR_ORIG_MAIN_NAME)))
TAR_ORIG_QEMU_NAME = $(SOURCE)_$(VERSION_UPSTREAM).orig-qemu.tar.gz
TAR_ORIG_QEMU = $(firstword $(wildcard ../$(TAR_ORIG_QEMU_NAME)) $(wildcard ../orig/$(TAR_ORIG_QEMU_NAME)))

orig: $(DIR_ORIG)
	rsync --delete --exclude debian --exclude .svk --exclude .svn -a $(DIR_ORIG)/ .

$(DIR_ORIG):
ifeq ($(TAR_ORIG_MAIN),)
	$(error Cannot find main orig tarball $(TAR_ORIG_MAIN_NAME))
else
	mkdir -p ../orig
	tar -C ../orig -xzf $(TAR_ORIG_MAIN)
endif
ifeq ($(TAR_ORIG_QEMU),)
	$(warning Cannot find qemu orig tarball $(TAR_ORIG_QEMU_NAME))
else
	tar -C $@ -xzf $(TAR_ORIG_QEMU)
endif

CONTROL_FILES += debian/changelog debian/bin/gencontrol.py $(wildcard debian/templates/*.in) 
CONTROL_FILES += $(wildcard debian/arch/defines) $(wildcard debian/arch/*/defines)
GENCONTROL = $(__MODULES_DIR)gencontrol.py
debian/control debian/rules.gen: $(CONTROL_FILES)
ifeq ($(wildcard debian/control.md5sum),)
	$(MAKE) -f debian/rules debian/control-real
else ifeq ($(VERSION_BINNMU),)
	md5sum --check debian/control.md5sum --status || \
		$(MAKE) -f debian/rules debian/control-real
else
	grep -v debian/changelog debian/control.md5sum | md5sum --check - --status || \
		$(MAKE) -f debian/rules debian/control-real
endif

debian/control-real: $(CONTROL_FILES)
	debian/bin/gencontrol.py
	md5sum $^ > debian/control.md5sum
	@echo
	@echo This target is made to fail intentionally, to make sure
	@echo that it is NEVER run during the automated build. Please
	@echo ignore the following error, the debian/control file has
	@echo been generated SUCCESSFULLY.
	@echo
	exit 1

.PHONY: clean build binary-indep binary-arch binary

## xen 4.2.2

=== debian/changelog ===
xen (4.2.2-0ubuntu1) saucy; urgency=low

  * Update to new upstream stable version (4.2.2). Dropped patches:
    - CVE-2012-5634
    - CVE-2013-0153-1 to -4
    - CVE-2013-1917
    - CVE-2013-1919
    - CVE-2013-1920
    - xsa34-4.2.patch
    - xsa35-4.2-with-xsa34.patch
    - xsa38.patch
    - qemu-cve-2012-6075-1.patch and qemu-cve-2012-6075-2.patch
    - 0008-vmx-Simplify-cr0-update-handling-by-deferring-cr4-ch.patch
    - 0009-VMX-disable-SMEP-feature-when-guest-is-in-non-paging.patch
    - 0010-VMX-Always-disable-SMEP-when-guest-is-in-non-paging-.patch
    - gcc48-ftbfs.patch
    - gcc48-ftbfs-2.patch
  * Included upstream changes:
    - IOMMU/ATS: fix maximum queue depth calculation
    - nested vmx: fix rflags status in virtual vmexit
    - nested vmx: fix handling of RDTSC
    - nested vmx: fix DR access VM exit
    - nested vmx: enable IA32E mode while do VM entry
    - nested vmx: fix interrupt delivery to L2 guest
    - x86: fix assertion in get_page_type()
    - x86/HPET: fix FSB interrupt masking
    - IOMMU: imply "verbose" from "debug"
    - scheduler: fix rate limit range checking
    - x86, amd: Disable way access filter on Piledriver CPUs
    - passthrough/domctl: use correct struct in union
    - x86: compat_show_guest_stack() should not truncate MFN
    - VT-d: fix interrupt remapping source validation for devices
      behind legacy bridges
    - Config.mk: delete accidentally introduced drivel
    - x86_32: don't allow use of nested HVM
    - xen: Do not allow guests to enable nested HVM on themselves
    - ACPI: acpi_table_parse() should return handler's error code
    - AMD,IOMMU: Clean up old entries in remapping tables when creating
      new one
    - AMD,IOMMU: Disable IOMMU if SATA Combined mode is on
    - AMD,IOMMU: Make per-device interrupt remapping table default
    - tools/ocaml: oxenstored: Be more paranoid about ring reading
    - oxenstored: Enforce a maximum message size of 4096 bytes
    - xen: sched_credit: improve picking up the idle CPU for a VCPU
    - x86: consistently mask floating point exceptions
    - x86/AMD: Enable WC+ memory type on family 10 processors
    - x86/hvm: fix RTC setting.
    - x86: restore (optional) forwarding of PCI SERR induced NMI to Dom0
    - fix acpi_dmar_zap/reinstate() (fixes S3 regression)
    - vmx: Simplify cr0 update handling by deferring cr4 changes to the
      cr4 handler.
    - VMX: disable SMEP feature when guest is in non-paging mode
    - unmodified_drivers: __devinit was removed in linux-3.8
    - tools/ocaml: oxenstored: correctly handle a full ring.
    - AMD IOMMU: also spot missing IO-APIC entries in IVRS table
    - tools/ocaml: libxc bindings: Fix SBDF encoding
    - libxl_json: Export json_object related function.
    - libxl_json: Remove JSON_ERROR from enum.
    - libxl_json: Replace JSON_TRUE/FALSE by JSON_BOOL.
    - libxl_json: Introduce libxl__json_object_to_yajl_gen.
    - libxl_qmp: Introduces helpers to create an argument list.
    - libxl_qmp: Use qmp_parameters_* functions for param list of a
      QMP command.
    - libxl_qmp: Simplify run of single QMP commands.
    - libxl_qmp: Introduce libxl__qmp_set_global_dirty_log.
    - libxl_dom: Call the right switch logdirty for the right DM.
    - libxl: libxl__qmp_save: Add filename as JSON parameter to
      xen-save-devices-state
    - libxl: Allow migration with qemu-xen.
    - gcc4.8 build fix: Add -Wno-unused-local-typedefs to CFLAGS.
    - xenoprof: avoid division by 0
    - AMD IOMMU: don't BUG() when we don't have to
    - libxl: rename "abs" variables to "absolute"
    - libxl: fix stale fd event callback race
    - libxl: fix stale timeout event callback race
    - x86_32: fix acpi_dmar_init()
    - tools: Fix memset(&p,0,sizeof(p)) idiom in several places.
    - tools/libxl: Improve videoram setting
    - x86/mm: Take the p2m lock even in shadow mode.
    - x86/nhvm: properly clean up after failure to set up all vCPU-s
    - honor ACPI v4 FADT flags
    - x86: fix null pointer dereference in intel_get_extended_msrs()
    - IOMMU, AMD Family15h Model10-1Fh erratum 746 Workaround
    - x86: fix CMCI injection
    - x86/setup: don't relocate the VGA hole.
    - vmx: fix handling of NMI VMEXIT.
    - Avoid stale pointer when moving domain to another cpupool
    - fix compat memory exchange op splitting
    - x86: make certain memory sub-ops return valid values
    - SEDF: avoid gathering vCPU-s on pCPU0
    - x86: defer processing events on the NMI exit path
    - credit1: Use atomic bit operations for the flags structure
    - xentrace: fix off-by-one in calculate_tbuf_size
    - fix domain unlocking in some xsm error paths
    - x86/MSI: add mechanism to fully protect MSI-X table from PV
      guest accesses
    - powernow: add fixups for AMD P-state figures
    - x86/MCA: suppress bank clearing for certain injected events
    - AMD/IOMMU: Process softirqs while building dom0 iommu mappings
    - VT-d: Enumerate IOMMUs when listing capabilities
    - IOMMU: properly check whether interrupt remapping is enabled
    - VT-d: deal with 5500/5520/X58 errata
    - AMD IOMMU: allow disabling only interrupt remapping when certain
      IVRS consistency checks fail
    - ACPI/APEI: fix ERST MOVE_DATA instruction implementation
    - ACPI/ERST: Name table in otherwise opaque error messages
    - ACPI/APEI: Unlock apei_iomaps_lock on error path
    - ACPI, APEI: Add apei_exec_run_optional
    - ACPI: fix APEI related table size checking
    - x86: reserve pages when SandyBridge integrated graphics
    - x86/EFI: permit setting variable with non-zero attributes
    - hvm: Clean up vlapic_reg_write() error propagation.
    - defer event channel bucket pointer store until after XSM checks
    - x86: irq_move_cleanup_interrupt() must ignore legacy vectors
    - x86/S3: Restore broken vcpu affinity on resume
    - VMX: Always disable SMEP when guest is in non-paging mode
    - x86/mm/shadow: spurious warning when unmapping xenheap pages.


=== debian/control ===
--- 
+++ 
@@ -5,7 +5,7 @@
 XSBC-Original-Maintainer: Debian Xen Team <pkg-xen-devel@lists.alioth.debian.org>
 Uploaders: Guido Trotter <ultrotter@debian.org>, Bastian Blank <waldi@debian.org>
 Standards-Version: 3.9.2
-Build-Depends: debhelper (>> 7), dpkg-dev (>= 1.16.0~), lsb-release, python-dev, bcc, gcc-multilib, e2fslibs-dev, iasl, kvm-ipxe, libaio-dev, libglib2.0-dev, libgnutls-dev, liblzma-dev, libncurses5-dev, libpci-dev, libyajl-dev, pkg-config, uuid-dev, zlib1g-dev, ocaml-nox, dh-ocaml, ocaml-findlib, libssl-dev
+Build-Depends: debhelper (>> 7), dpkg-dev (>= 1.16.0~), lsb-release, python-dev, bcc, gcc-multilib, e2fslibs-dev, iasl, ipxe-qemu, seabios, libaio-dev, libglib2.0-dev, libgnutls-dev, liblzma-dev, libncurses5-dev, libpci-dev, libyajl-dev, pkg-config, uuid-dev, zlib1g-dev, ocaml-nox, dh-ocaml, ocaml-findlib, libssl-dev
 Build-Depends-Indep: graphviz, ghostscript, texlive-fonts-recommended, texlive-font-utils, texlive-latex-recommended
 XS-Python-Version: current
